"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = uploadError;

var _azureStorage = _interopRequireDefault(require("azure-storage"));

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// not very general, that's okay
async function uploadError(data) {
  const blobService = _azureStorage.default.createBlobService(process.env.AZ_CONNECTION_STRING);

  const container = "cardcore-builds";
  const remoteName = `${process.env.DRONE_COMMIT}-error.json`;

  const slackNotify = async function (text) {
    if (typeof text !== "string") {
      text = JSON.stringify(text);
    }

    await (0, _isomorphicFetch.default)(process.env.SLACK_NOTIFICATION, {
      method: "POST",
      body: JSON.stringify({
        text
      }),
      headers: {
        "content-type": "application/json"
      }
    });
  };

  return new Promise((resolve, reject) => {
    blobService.createContainerIfNotExists(container, error => {
      if (error) return reject(error);
      blobService.createBlockBlobFromText(container, remoteName, JSON.stringify(data), {
        contentSettings: {
          contentType: "application/json"
        }
      }, async (error, result) => {
        if (error) reject(error);
        resolve(slackNotify(`simulation error: https://streamplace.blob.core.windows.net/${container}/${remoteName}`)); // console.dir(result, { depth: null, colors: true });
        // resolve();
      });
    });
  });
}
//# sourceMappingURL=upload-error.js.map